﻿import mx.utils.Delegate;

class Intro{

	private var loaded:Boolean = false;
	private var loadMusic:Boolean = false;	
	private var loadSound:Boolean = false;

	
	private var time:Number = 0;
	private var xmlData:XML;
	
	private var scene:Scene;
	private var scenes:Array = new Array();
	private var nxt:Number = 0;
	
	private var newScene:Boolean = false;
	private var endIntro:Boolean = false;
	
	private var visA:Boolean = false;
	private var visB:Boolean = false;
	private var visC:Boolean = false;
	private var visD:Boolean = false;
	private var visE:Boolean = false;
	private var visF:Boolean = false;

	//Konstruktor
	public function Intro(){		
		xmlData = new XML();
		
		xmlData.ignoreWhite=true;
		xmlData.load("intro.xml");
		
		xmlData.onLoad = Delegate.create(this, buildIntro);
			
	}
		
	//erzeugt die szenen und speichert sie in einem Array
	public function buildIntro(success:Boolean){
		
		if(success){
			for(var i = 0; i < xmlData.firstChild.childNodes.length; i++){
					
				var sc:Scene = new Scene();
					
				sc.setTime(xmlData.firstChild.childNodes[i].attributes.time);
					
				sc.setMusic(xmlData.firstChild.childNodes[i].childNodes[0].attributes.file);
				sc.setSound(xmlData.firstChild.childNodes[i].childNodes[1].attributes.file);
					
				sc.setAImg(xmlData.firstChild.childNodes[i].childNodes[2].attributes.file);
				sc.setEmptyImgA(xmlData.firstChild.childNodes[i].childNodes[2].attributes.empty);
				sc.setATime(xmlData.firstChild.childNodes[i].childNodes[2].attributes.time);
					
				sc.setBImg(xmlData.firstChild.childNodes[i].childNodes[3].attributes.file);
				sc.setEmptyImgB(xmlData.firstChild.childNodes[i].childNodes[3].attributes.empty);
				sc.setBTime(xmlData.firstChild.childNodes[i].childNodes[3].attributes.time);
					
				sc.setCImg(xmlData.firstChild.childNodes[i].childNodes[4].attributes.file);
				sc.setEmptyImgC(xmlData.firstChild.childNodes[i].childNodes[4].attributes.empty);
				sc.setCTime(xmlData.firstChild.childNodes[i].childNodes[4].attributes.time);
					
				sc.setDImg(xmlData.firstChild.childNodes[i].childNodes[5].attributes.file);
				sc.setEmptyImgD(xmlData.firstChild.childNodes[i].childNodes[5].attributes.empty);
				sc.setDTime(xmlData.firstChild.childNodes[i].childNodes[5].attributes.time);
				
				sc.setEImg(xmlData.firstChild.childNodes[i].childNodes[6].attributes.file);
				sc.setEmptyImgE(xmlData.firstChild.childNodes[i].childNodes[6].attributes.empty);
				sc.setETime(xmlData.firstChild.childNodes[i].childNodes[6].attributes.time);
				
				sc.setFImg(xmlData.firstChild.childNodes[i].childNodes[7].attributes.file);
				sc.setEmptyImgF(xmlData.firstChild.childNodes[i].childNodes[7].attributes.empty);
				sc.setFTime(xmlData.firstChild.childNodes[i].childNodes[7].attributes.time);
				
				////trace("scene: "+sc.getAImg());
				
				scenes[i] = sc;
				
				////trace("scene[i]: "+scenes[i].getAImg());
				
			}
			
			this.scene = scenes[0];
			this.nxt++;
			this.newScene = true;
			
			
			this.loaded = true;
				
			////trace("zuende geladen!!");
		}
		
	}

	
	public function getLoaded():Boolean{
		return this.loaded;
	}
	
	public function timePlus():Void{
		this.time++;
		
		////trace(time);
		
		if(time == scene.getTime()){
			this.time = 0;
			//trace("szene zuende");
			
			if(scenes.length>nxt){
				//trace("szenenwechsel")
				scene = scenes[nxt];
				nxt++;
				this.visA = false;
				this.visB = false;
				this.visC = false;
				this.visD = false;
				this.visE = false;
				this.visF = false;
				
				this.newScene = true;
				
				//trace("scene.getMusic "+scene.getMusic());
				//trace("scene.getSound "+scene.getSound());
				
				if("no" == scene.getMusic()){
					this.loadMusic = false;
					//trace("no musicload");
				} else {
					//trace("musicload");
					this.loadMusic = true;
				}
				
				if("no" == scene.getSound()){
					this.loadSound = false;
					//trace("no soundload");
				} else {
					this.loadSound = true;
					//trace("soundload");
				}
				
			} else {
				//trace("intro beendet");
				this.endIntro = true;
			}
		} else {
			this.newScene = false;
		}
		
		if(time == scene.getTimeA()){
			this.visA = true;
			//trace("a jetzt zeichnen!");
		} else {
			this.visA = false;
		}
		
		if(time == scene.getTimeB()){
			this.visB = true;
		} else {
			this.visB = false;
		}
		
		if(time == scene.getTimeC()){
			this.visC = true;
		} else {
			this.visC = false;
		}
		
		if(time == scene.getTimeD()){
			this.visD = true;
			//trace("D jetzt zeichnen");
		} else {
			this.visD = false;
		}
		
		if(time == scene.getTimeE()){
			this.visE = true;
			//trace("E jetzt zeichnen");
		} else {
			this.visE = false;
		}
		
		if(time == scene.getTimeF()){
			this.visF = true;
			//trace("F jetzt zeichnen");
		} else {
			this.visF = false;
		}
		
	}
	
	public function getScene():Scene{
		return this.scene;
	}
	
	public function getNewScene():Boolean{
		return this.newScene;
	}
	
	public function getEndIntro():Boolean{
		return this.endIntro;
	}
	
	public function getA():Boolean{
		return this.visA;
	}
	
	public function getB():Boolean{
		return this.visB;
	}
	
	public function getC():Boolean{
		return this.visC;
	}
	
	public function getD():Boolean{
		return this.visD;
	}
	
	public function getE():Boolean{
		return this.visE;
	}
	
	public function getF():Boolean{
		return this.visF;
	}
	
	public function getLoadMusic():Boolean{
		return this.loadMusic;
	}
	
	public function getLoadSound():Boolean{
		return this.loadSound;
	}
}